/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* map.h:  Header file for lm_map.c                                 */
/*         Contains function declarations and preprocessor defined  */
/*         variables for map estimation.                            */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#define TINY 1.0e-9
#define TIME 100

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* small_map_fncts.c: A collection of functions used by lm_map, where */
/*                    each function uses <=5 arguments                */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

int   comp_map (double, double **, double **);

double rf (double);         
double cmH (double xx);     
double find_intv (double, double, int *z);

void get_init (int, double**, double**, double*, double);    
void swcpy (int*, int*, int*, int*);
void decide (double*);      
void pr_section(int, int);       
void d_invert (double **, double **, int);
void  reset_map (int, int, double **, double **, double **);
void  cpy_map (double **, double **);
void  pr_map (int, double **);
void  set_rc (int, int ***, double **);

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* large_map_fncts.c: A collection of functions used by lm_map, where */
/*                    each function uses >5 arguments                 */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

int mcemits (int, int, int, 
             int *, int ***, double **, double **, double **);
void  ludcmp (double **, int, int *, double *d);
void  lubksb (double **, int, int *, double *bnr);
void  reset_globs (int, int, int *, int *, int *);
void  lr_cdllr (int, double *, double **, double **, double **,
                int ***, int ***);
double logLR (double **, double **, int, int ***, int ***, double **,
              double **, int *, int);
void sait (int, int, int ***, int, double **, double **, double **,
           double **);
void obs_info (int, double **, int ***, int ***, int, double **,
               double **, double **, int, int);

