/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "traits.h"

/**
 * Setup structures for recombination, inheritance indicators, genes,
 * and loci
 */
void setMaps (int nh)
{
   int   sx;
   int   trtloc0[3] = { 0, 0, 0 };
   double trtrec0[3] = { .5, .5, .5 };

   /* allocate and set arrays of marker and trait positions
    * and recombination fractions  (for sampler setup, trait is unlinked).
    *                                        int chromo[nh+1][NLoci]
    *                                        revchro[nh+1][NLoci]
    *                                        double xecomo[2][nh+1][NLoci] */
   alloc_chromo ((NLoci - 1), nh);

   /* Lodscore programs have test positions for trait; start with unlinked */
   if (NVary)
      for (sx = FEM; sx <= MAL; sx++)
         set_chromosomes ((NLoci - 1), Marek[sx], nh, trtloc0, trtrec0, sx);
   /* Autozyg programs have linked or unlinked trait or unused trait locus */
   else
      for (sx = FEM; sx <= MAL; sx++)
         set_chromosomes ((NLoci - 1), Marek[sx], 0, &Loc0, &Rec0[sx], sx);

   return;
}

/*  Flag marker loci specified as traits.  Set up the trait structures.       */

void setLocTyp (void)
{
   int  *loc_flags;
   int   ntraits, nmarkers;

   loc_flags = malloc ((NMarks + 1) * sizeof (int));
   alloc_chk (WHERE, loc_flags);

   /* Set up trait structures, one for each locus.  These subroutines refer   */
   /* to the "GLOBAL struct Trait traits[NMarks+1]", as defined in traits.h.  */
   ntraits = set_traits (NMarks, loc_flags);
   nmarkers = print_traits (ntraits, loc_flags);

   if (loc_flags)
   {
      free (loc_flags);
      loc_flags = NULL;
   }

   return;
}
