/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int proc_free (void)
{
   /* Free the data structures defined in parsepars.h, parsedrop.h and        */
   /* parselods.h.                                                            */

/* KINS_PTR p_kin;                                                            */
   SIM_PTR p_sim;
   TRAITTLOC_PTR p_tt;
   INHERTLOC_PTR p_it;
   TRAITDATA_PTR p_td;
   MAP_PTR p_map;

   VMAP_PTR p_vmp;
   PRNTVMAP_PTR p_ptvmp;
   PXMAP_PTR p_pxmp;
   PIMAP_PTR p_pimp;
   PSMAP_PTR p_psmp;
   XMAP_PTR p_xmp;
   IMAP_PTR p_imp;

   LOCUS_PTR p_loc;
   INCO_PENE_PTR p_ipn;
   GENO_MEANS_PTR p_gmn;
   VARI_PTR p_var;
   TRTPED_PTR p_tp;

   MARKDAT_PTR p_mdt;
   MARKNAM_PTR p_mnm;

   PROBGAM_PTR p_pg;
   INDNAM_PTR p_in;

   LOCWND_PTR p_lw;
   WNDPAT_PTR p_wp;

   TRAITEFF_PTR p_te;
   FIXEDEFF_PTR p_fe;

   TLLIST_PTR p_tll;
   PRNTMAP_PTR p_m;
   PRDIST_PTR p_l;

   void *p_nxt, *p_nxl;
   int   sx, s2;

#if 0
   /* Because the KinNam array used within the kin program is initialized by  */
   /* pointing to names stored in various kinship_node's, proc_free () cannot */
   /* free up these kinship_node's.                                           */

   /* Free the memory used for kinship kinship_node's.                        */
   p_kin = first_kins_node;
   while (p_kin)
   {
      p_nxt = p_kin->p_next;
      free_1d ((void *) &p_kin->p_nams);
      free (p_kin);
      p_kin = p_nxt;
   }
   first_kins_node = NULL;

   /* Free the memory used for inbreeding kinship_node's.                     */
   p_kin = first_inbreed_node;
   while (p_kin)
   {
      p_nxt = p_kin->p_next;
      free_1d ((void *) &p_kin->p_nams);
      free (p_kin);
      p_kin = p_nxt;
   }
   first_inbreed_node = NULL;

   /* Free the memory used for two-locus inbreeding kinship_node's.           */
   p_kin = first_2loc_node;
   while (p_kin)
   {
      p_nxt = p_kin->p_next;
      free_1d ((void *) &p_kin->p_nams);
      free (p_kin);
      p_kin = p_nxt;
   }
   first_2loc_node = NULL;
#endif

   /* Free the memory used for sim_chrom_node's.                              */
   p_sim = first_sim_chrom_node;
   while (p_sim)
   {
      p_nxt = p_sim->p_next;
      free_1d ((void *) &p_sim->p_mark);
      free_1d ((void *) &p_sim->p_tloc);
      free (p_sim);
      p_sim = p_nxt;
   }
   first_sim_chrom_node = NULL;

   /* Free the memory used for the sim_trait_node.                            */
   if (sim_traits)
   {
      free_1d ((void *) &sim_traits->p_trait);
      free (sim_traits);
      sim_traits = NULL;
   }

   /* Free the memory used for trait_tloc_node's.                             */
   p_tt = first_trait_tloc_node;
   while (p_tt)
   {
      p_nxt = p_tt->p_next;
      free_1d ((void *) &p_tt->p_tloc);
      free (p_tt);
      p_tt = p_nxt;
   }
   first_trait_tloc_node = NULL;

   /* Free the memory used for inher_tloc_node's.                             */
   p_it = first_inher_tloc_node;
   while (p_it)
   {
      p_nxt = p_it->p_next;
      free_1d ((void *) &p_it->p_tloc);
      free (p_it);
      p_it = p_nxt;
   }
   first_inher_tloc_node = NULL;

   /* Free the memory used for trait_data_node's.                             */
   p_td = first_trait_data_node;
   while (p_td)
   {
      p_nxt = p_td->p_next;
      free (p_td);
      p_td = p_nxt;
   }
   first_trait_data_node = NULL;

   /* Free the memory used for the sim_unlnkd_tloc_node.                      */
   if (sim_unlnkd_tlocs)
   {
      free_1d ((void *) &sim_unlnkd_tlocs->p_tloc);
      free (sim_unlnkd_tlocs);
      sim_unlnkd_tlocs = NULL;
   }

   /* Free the memory used for marker map_node's and dist_list's.             */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_map = first_mark_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         free_1d ((void *) &p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_mark_map_node[sx] = NULL;
   }

   /* Free the memory used for tloc map_node's and dist_list's.               */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_map = first_tloc_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         free_1d ((void *) &p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_tloc_map_node[sx] = NULL;
   }

   /* Free the memory used for the unlnkd_map_node.                           */
   if (unlnkd_tloc_map_node)
   {
      free_1d ((void *) &unlnkd_tloc_map_node->p_udist);
      free (unlnkd_tloc_map_node);
      unlnkd_tloc_map_node = NULL;
   }

   /* Free the memory used for tloc vmap_node's and positions.                */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_vmp = first_tloc_vmap_node[sx];
      while (p_vmp)
      {
         p_nxt = p_vmp->p_next;
         for (s2 = FEM; s2 <= AVG; ++s2)
         {
            p_ptvmp = p_vmp->p_vprntmap[s2];
            if (p_ptvmp)
            {
               p_pxmp = p_ptvmp->p_beg;
               if (p_pxmp)
               {
                  free_1d ((void *) &p_pxmp->p_dist);
                  free_1d ((void *) &p_pxmp->p_rf);
                  free (p_pxmp);
               }

               p_pxmp = p_ptvmp->p_end;
               if (p_pxmp)
               {
                  free_1d ((void *) &p_pxmp->p_dist);
                  free_1d ((void *) &p_pxmp->p_rf);
                  free (p_pxmp);
               }

               p_pimp = p_ptvmp->p_intv;
               while (p_pimp)
               {
                  p_nxl = p_pimp->p_next;
                  free_1d ((void *) &p_pimp->p_prop);
                  free (p_pimp);
                  p_pimp = p_nxl;
               }

               p_psmp = p_ptvmp->p_sintv;
               while (p_psmp)
               {
                  p_nxl = p_psmp->p_next;
                  free_1d ((void *) &p_psmp->p_sdist);
                  free_1d ((void *) &p_psmp->p_rf);
                  free_1d ((void *) &p_psmp->p_locdist);
                  free_1d ((void *) &p_psmp->p_star);
                  free (p_psmp);
                  p_psmp = p_nxl;
               }
               free (p_ptvmp);
            }
         }

         p_xmp = p_vmp->p_pos;
         if (p_xmp)
         {
            free_1d ((void *) &p_xmp->p_dist);
            free_1d ((void *) &p_xmp->p_rf);
            free (p_xmp);
         }

         p_xmp = p_vmp->p_beg;
         if (p_xmp)
         {
            free_1d ((void *) &p_xmp->p_dist);
            free_1d ((void *) &p_xmp->p_rf);
            free (p_xmp);
         }

         p_xmp = p_vmp->p_end;
         if (p_xmp)
         {
            free_1d ((void *) &p_xmp->p_dist);
            free_1d ((void *) &p_xmp->p_rf);
            free (p_xmp);
         }

         p_imp = p_vmp->p_intv;
         while (p_imp)
         {
            p_nxl = p_imp->p_next;
            free_1d ((void *) &p_imp->p_prop);
            free (p_imp);
            p_imp = p_nxl;
         }

         free_1d ((void *) &p_vmp->p_marker_nums);
         free (p_vmp);
         p_vmp = p_nxt;
      }
      first_tloc_vmap_node[sx] = NULL;
   }

   /* Free the memory used for marker locus_node's.                           */
   p_loc = first_mark_locus_node;
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0) /* Decrement number of loci */
      {                                 /* Remove freq_node if no ptrs.       */
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_mark_locus_node = NULL;

   /* Free the memory used for tloc locus_node's.                             */
   p_loc = first_tloc_locus_node;
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0)
      {
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_tloc_locus_node = NULL;

   /* Free the memory used for inco_pene_node's.                              */
   p_ipn = first_inco_pene_node;
   while (p_ipn)
   {
      p_nxt = p_ipn->p_next;
      free_1d ((void *) &p_ipn->penetrances);
      free (p_ipn);
      p_ipn = p_nxt;
   }
   first_inco_pene_node = NULL;

   /* Free the memory used for geno_means_node's.                             */
   p_gmn = first_geno_means_node;
   while (p_gmn)
   {
      p_nxt = p_gmn->p_next;
      free_1d ((void *) &p_gmn->means);
      free (p_gmn);
      p_gmn = p_nxt;
   }
   first_geno_means_node = NULL;

   /* Free the memory used for additive vari_node's.                          */
   p_var = first_addi_node;
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_addi_node = NULL;

   /* Free the memory used for residual vari_node's.                          */
   p_var = first_resi_node;
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_resi_node = NULL;

   /* Free the memory used for traitped_node's.                               */
   p_tp = first_trtped_node;
   while (p_tp)
   {
      p_nxt = p_tp->p_next;
      free (p_tp);
      p_tp = p_nxt;
   }
   first_trtped_node = NULL;

   /* Free the memory used for markdat_node's.                                */
   p_mdt = first_markdat_node;
   while (p_mdt)
   {
      p_nxt = p_mdt->p_next;
      free_1d ((void *) &p_mdt->p_obs);
      free_1d ((void *) &p_mdt->p_alls);
      free (p_mdt);
      p_mdt = p_nxt;
   }
   first_markdat_node = NULL;

   /* Free the memory used for marknam_node's.                                */
   p_mnm = first_marknam_node;
   while (p_mnm)
   {
      p_nxt = p_mnm->p_next;
      free_1d ((void *) &p_mnm->p_nams);
      free (p_mnm);
      p_mnm = p_nxt;
   }
   first_marknam_node = NULL;

   /* Free the memory used for probgam_node's.                                */
   p_pg = first_probgam_node;
   while (p_pg)
   {
      p_nxt = p_pg->p_next;
      free_1d ((void *) &p_pg->p_pglist);
      free (p_pg);
      p_pg = p_nxt;
   }
   first_probgam_node = NULL;

   /* Free the memory used for indnam_node's.                                 */
   p_in = first_dispnam_node;
   while (p_in)
   {
      p_nxt = p_in->p_next;
      free_1d ((void *) &p_in->p_namlist);
      free (p_in);
      p_in = p_nxt;
   }
   first_dispnam_node = NULL;

   /* Free the memory used for locwind_node's.                                */
   p_lw = first_locwind_node;
   while (p_lw)
   {
      p_nxt = p_lw->p_next;
      free (p_lw);
      p_lw = p_nxt;
   }
   first_locwind_node = NULL;

   /* Free the memory used for windpat_node's.                                */
   p_wp = first_windpat_node;
   while (p_wp)
   {
      p_nxt = p_wp->p_next;
      free_1d ((void *) &p_wp->p_pats);
      free (p_wp);
      p_wp = p_nxt;
   }
   first_windpat_node = NULL;

   /* Free the memory used for trait_eff_node's and fixed_eff_node's.         */
   p_te = first_trait_eff_node;
   while (p_te)
   {
      p_nxt = p_te->p_next;
      free_1d ((void *) &p_te->eff_nums);
      p_fe = p_te->p_eff_list;
      while (p_fe)
      {
         p_nxl = p_fe->p_next;
         free_1d ((void *) &p_fe->startff);
         free (p_fe);
         p_fe = p_nxl;
      }
      free (p_te);
      p_te = p_nxt;
   }
   first_trait_eff_node = NULL;

   /* Free the data structures defined in parsedrop.h.                        */

   /* Free the memory used for tllist_node's.                                 */
   p_tll = first_tllist_node;
   while (p_tll)
   {
      p_nxt = p_tll->p_next;
      free (p_tll);
      p_tll = p_nxt;
   }
   first_tllist_node = NULL;

   /* Free the memory used for printmap_node's.                               */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_m = first_prntmap_node[sx];
      while (p_m)
      {
         p_nxt = p_m->p_next;
         p_l = p_m->p_locus;
         while (p_l)
         {
            p_nxl = p_l->p_next;
            free (p_l);
            p_l = p_nxl;
         }
         free (p_m);
         p_m = p_nxt;
      }
      first_prntmap_node[sx] = NULL;
   }

   return TRUE;
}
