/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int out_ped_fil (void)                  /* output pedgree file               */
{
   if (chk_stat ())
      chk_fil (OPED);

   return err_typ;
}

int out_rw_ped_fil (void)               /* output overwrite pedgree file     */
{
   if (chk_stat ())
      chk_fil (OPED);
   set_rewrt (OPED);

   return err_typ;
}

int out_resc_fil (void)                 /* output rescue file                */
{
   if (chk_stat ())
      chk_fil (ORESC);

   return err_typ;
}

int out_scor_fil (void)                 /* output scores file                */
{
   if (chk_stat ())
      chk_fil (OSCORE);

   return err_typ;
}

int out_rw_scor_fil (void)              /* Output overwrite scores file.      */
{
   if (chk_stat ())
      chk_fil (OSCORE);
   set_rewrt (OSCORE);

   return err_typ;
}

int out_rb_est_fil (void)               /* output r-b estimates file         */
{
   if (chk_stat ())
      chk_fil (ORBEST);

   return err_typ;
}

int out_seed_fil (void)                 /* output seed file                  */
{
   if (chk_stat ())
      chk_fil (OSEED);

   return err_typ;
}

int out_rw_seed_fil (void)              /* output overwrite seed file         */
{
   if (chk_stat ())
      chk_fil (OSEED);
   set_rewrt (OSEED);

   return err_typ;
}

int out_xtra_fil (void)                 /* output extra file                 */
{
   if (chk_stat ())
      chk_fil (OXTR);

   return err_typ;
}

int out_rw_xtra_fil (void)              /* output overwrite xtra file        */
{
   if (chk_stat ())
      chk_fil (OXTR);
   set_rewrt (OXTR);

   return err_typ;
}

int out_ord_fath (void)                 /* output record father mother       */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (parentOrdOut == MA1ST)
         err_typ = ERR_ORD;
      parentOrdOut = PA1ST;
   }
   return err_typ;
}

int out_ord_moth (void)                 /* output record mother father       */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (parentOrdOut == PA1ST)
         err_typ = ERR_ORD;
      parentOrdOut = MA1ST;
   }
   return err_typ;
}

int out_corr (void)                     /* output correlations               */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IOCor = Y;
   }
   return err_typ;
}

int out_fin_pheno (void)                /* output final adjusted phenotypes  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      FinPheno = Y;
   }
   return err_typ;
}

int out_covar (void)                    /* output covariances                */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IOCor = N;
   }
   return err_typ;
}

int out_scor_iter (void)                /* output scores every scored MC iter */
{
   if (chk_stat ())
   {
      chk_repeat ();
      FilIt = j_par[0];
   }
   return err_typ;
}

int out_space (void)                    /* output spacing statement          */
{
   if (chk_stat ())
   {
      chk_repeat ();
      ItWt = j_par[0];
   }
   return err_typ;
}

int out_mark_seeds (void)               /* output marker seeds only          */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (TraitSeedsOut)
      {
         TraitSeedsOut = N;
         err_typ = ERD_OTS;
      }
      MarkSeedsOut = Y;
   }
   return err_typ;
}

int out_trait_seeds (void)              /* output trait seeds only           */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MarkSeedsOut)
      {
         MarkSeedsOut = N;
         err_typ = ERD_OMS;
      }
      TraitSeedsOut = Y;
   }
   return err_typ;
}

int out_samp_seeds (void)               /* output sampler seeds only         */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (PermSeedsOut)
      {
         PermSeedsOut = N;
         err_typ = ERA_OPS;
      }
      SamplSeedsOut = Y;
   }
   return err_typ;
}

int out_perm_seeds (void)               /* output permutation seeds only     */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (SamplSeedsOut)
      {
         SamplSeedsOut = N;
         err_typ = ERA_OSS;
      }
      PermSeedsOut = Y;
   }
   return err_typ;
}

int out_unobs (void)                    /* output unobserved variables       */
{
   if (chk_stat ())
   {
      chk_repeat ();
      ObsOut = Y;
   }
   return err_typ;
}

int out_maps_avg (void)                 /* output maps gender averaged       */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MapTyp == SEX_SPEC || MapTyp == BOTH)
         err_typ = ERA_MTR;
      MapTyp = SEX_AVG;
   }
   return err_typ;
}

int out_maps_spc (void)                 /* output maps gender specific       */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MapTyp == SEX_AVG || MapTyp == BOTH)
         err_typ = ERA_MTR;
      MapTyp = SEX_SPEC;
   }
   return err_typ;
}

int out_maps_both (void)                /* output maps both                  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MapTyp == SEX_SPEC || MapTyp == SEX_AVG)
         err_typ = ERA_MTR;
      MapTyp = BOTH;
   }
   return err_typ;
}

int out_found_labs (void)               /* output founder labels             */
{
   if (chk_stat ())
      chk_repeat ();
   LabelsOut = Y;

   return err_typ;
}

int out_tr_vars (void)                  /* output latent trait variables     */
{
   if (chk_stat ())
      chk_repeat ();
   LatentOut = Y;

   return err_typ;
}

int out_chron (void)                    /* output pedigree chronological     */
{
   if (chk_stat ())
      chk_repeat ();
   ChronOut = Y;

   return err_typ;
}

int out_fgls (void)                     /* output founder genome labels       */
{
   if (chk_stat ())
      chk_repeat ();
   PrintFGLs = Y;

   return err_typ;
}

int out_mis (void)                      /* output meiosis indicators          */
{
   if (chk_stat ())
      chk_repeat ();
   PrintMIs = Y;

   return err_typ;
}
