/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*  function is:
 *          checkNam()
 */

#include "pedchk.h"

/* checkNam:  checks for duplicate names in the pedigree */

int checkNam (void)
{

   KEYS_PP ppK;
   int   i;
   char  fNam[MAXNAMLEN + 1];
   int   nDup = 0;

   ppK = ppKeyTab;

   for (i = 0; i < nInd - 1; ++i)
   {
      if (strncmp ((*(ppK + 1))->nam, (*ppK)->nam, MAXNAMLEN) == 0)
      {
         ++nDup;
         if (nDup == 1)
            strncpy (fNam, (*ppK)->nam, MAXNAMLEN + 1);
      }
      ++ppK;
   }
   if (nDup == 0)
      return OK;

   if (nDup == 1)
      give_err (ERC_dp1, "checkNam", fNam);
   else
      give_err (ERC_dup, "checkNam", nDup, fNam);

   return !OK;
}
